summary refs log tree commit diff
path: root/pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh
diff options
context:
space:
mode:
authorArmijn Hemel <armijn@gpl-violations.org>2005-11-29 01:40:33 +0000
committerArmijn Hemel <armijn@gpl-violations.org>2005-11-29 01:40:33 +0000
commit508cd3a3e8e079288d2b51e29f63294888067e2b (patch)
tree7c023099c0b0293666156ca7181aee60734e62b9 /pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh
parent0cf7a938271ffa927ac9520f098e647f20fa7a7c (diff)
downloadnixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar.gz
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar.bz2
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar.lz
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar.xz
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.tar.zst
nixlib-508cd3a3e8e079288d2b51e29f63294888067e2b.zip
add a wrapper for cross compilers, which makes the correct link to the cross compiler. Only works for "gcc", haven't tried for g++ and the others
svn path=/nixpkgs/trunk/; revision=4317
Diffstat (limited to 'pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh')
-rw-r--r--pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh125
1 files changed, 125 insertions, 0 deletions
diff --git a/pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh b/pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh
new file mode 100644
index 000000000000..7de57afc3f81
--- /dev/null
+++ b/pkgs/build-support/gcc-cross-wrapper/gcc-wrapper.sh
@@ -0,0 +1,125 @@
+#! @shell@ -e
+
+if test -n "$NIX_GCC_WRAPPER_START_HOOK"; then
+    . "$NIX_GCC_WRAPPER_START_HOOK"
+fi
+
+if test -z "$NIX_GLIBC_FLAGS_SET"; then
+    . @out@/nix-support/add-flags
+fi
+
+. @out@/nix-support/utils
+
+
+# Figure out if linker flags should be passed.  GCC prints annoying
+# warnings when they are not needed.
+dontLink=0
+if test "$*" = "-v" -o -z "$*"; then
+    dontLink=1
+else
+    for i in "$@"; do
+        if test "$i" = "-c"; then
+            dontLink=1
+        elif test "$i" = "-S"; then
+            dontLink=1
+        elif test "$i" = "-E"; then
+            dontLink=1
+        elif test "$i" = "-E"; then
+            dontLink=1
+        elif test "$i" = "-M"; then
+            dontLink=1
+        elif test "$i" = "-MM"; then
+            dontLink=1
+        fi
+    done
+fi
+
+
+# Optionally filter out paths not refering to the store.
+params=("$@")
+if test "$NIX_ENFORCE_PURITY" = "1" -a -n "$NIX_STORE"; then
+    rest=()
+    n=0
+    while test $n -lt ${#params[*]}; do
+        p=${params[n]}
+        p2=${params[$((n+1))]}
+        if test "${p:0:3}" = "-L/" && badPath "${p:2}"; then
+            skip $p
+        elif test "$p" = "-L" && badPath "$p2"; then
+            n=$((n + 1)); skip $p2
+        elif test "${p:0:3}" = "-I/" && badPath "${p:2}"; then
+            skip $p
+        elif test "$p" = "-I" && badPath "$p2"; then
+            n=$((n + 1)); skip $p2
+        elif test "$p" = "-isystem" && badPath "$p2"; then
+            n=$((n + 1)); skip $p2
+        else
+            rest=("${rest[@]}" "$p")
+        fi
+        n=$((n + 1))
+    done
+    params=("${rest[@]}")
+fi
+
+
+# Add the flags for the C compiler proper.
+extraAfter=($NIX_CFLAGS_COMPILE)
+extraBefore=()
+
+if test "$dontLink" != "1"; then
+
+    # Add the flags that should only be passed to the compiler when
+    # linking.
+    extraAfter=(${extraAfter[@]} $NIX_CFLAGS_LINK)
+
+    # Add the flags that should be passed to the linker (and prevent
+    # `ld-wrapper' from adding NIX_LDFLAGS again).
+    for i in $NIX_LDFLAGS_BEFORE; do
+        extraBefore=(${extraBefore[@]} "-Wl,$i")
+    done
+    for i in $NIX_LDFLAGS; do
+	if test "${i:0:3}" = "-L/"; then
+	    extraAfter=(${extraAfter[@]} "$i")
+	else
+	    extraAfter=(${extraAfter[@]} "-Wl,$i")
+	fi
+    done
+    export NIX_LDFLAGS_SET=1
+
+    if test "$NIX_STRIP_DEBUG" = "1"; then
+        # Add executable-stripping flags.
+        extraAfter=(${extraAfter[@]} $NIX_CFLAGS_STRIP)
+    fi
+fi
+
+# Optionally print debug info.
+if test "$NIX_DEBUG" = "1"; then
+  echo "original flags to @gccProg@:" >&2
+  for i in "${params[@]}"; do
+      echo "  $i" >&2
+  done
+  echo "extraBefore flags to @gccProg@:" >&2
+  for i in ${extraBefore[@]}; do
+      echo "  $i" >&2
+  done
+  echo "extraAfter flags to @gccProg@:" >&2
+  for i in ${extraAfter[@]}; do
+      echo "  $i" >&2
+  done
+fi
+
+if test -n "$NIX_GCC_WRAPPER_EXEC_HOOK"; then
+    . "$NIX_GCC_WRAPPER_EXEC_HOOK"
+fi
+
+
+# Call the real `gcc'.  Filter out warnings from stderr about unused
+# `-B' flags, since they confuse some programs.  Deep bash magic to
+# apply grep to stderr (by swapping stdin/stderr twice).
+if test -z "$NIX_GCC_NEEDS_GREP"; then
+    @gccProg@ ${extraBefore[@]} "${params[@]}" ${extraAfter[@]}
+else
+    (@gccProg@ ${extraBefore[@]} "${params[@]}" ${extraAfter[@]} 3>&2 2>&1 1>&3- \
+        | (grep -v 'file path prefix' || true); exit ${PIPESTATUS[0]}) 3>&2 2>&1 1>&3-
+    exit $?
+fi